# -*- coding: utf-8 -*-
# Project : flacon
# File : preferences.py
# (c) Alexander Sokolov asokol@mail.ru
#
# This file is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This file is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA

from PyQt4 import QtGui, QtCore
from PyQt4.QtCore import *
import subprocess


class Preferences():
    
   #****************************************************************
   #
   #****************************************************************
    def __init__(self):
        self._values = {}
        
        # Programs *************************************************
        self._values['Encoder/ThreadCount'] = 8
    
        # Programs *************************************************
        self._programs = {'Programs/shntool': "shntool",
                          'Programs/flac':    "flac",
                          'Programs/mac':     "mac",
                          'Programs/oggenc':  "oggenc",
                          'Programs/lame':    "lame",
                          'Programs/wavpack': "wavpack", 
                         } 
                         
        for key in self._programs.keys():
            self._values[key]=''

        # FLAC *****************************************************
        self._values['Flac/Compression'] = 5 

        # OGG ******************************************************
        self._values['Ogg/UseQuality']  = True
        self._values['Ogg/Quality']     = 7
        self._values['Ogg/MinBitrate']  = ''
        self._values['Ogg/NormBitrate'] = ''
        self._values['Ogg/MaxBitrate']  = ''

        # MP3 ******************************************************
        self._values['Mp3/Preset']  = 'avrStandard'
        self._values['Mp3/Bitrate'] = '320'
        self._values['Mp3/Quality'] = 4


   #****************************************************************
   # Load settings.
   #****************************************************************
    def load(self, settings):
        for key, val in self._values.iteritems():
            self._values[key] = settings.value(key, QVariant(val))
        self.findPrograms()

   #****************************************************************
   # Write settings.
   #****************************************************************
    def write(self, settings):
        for key, val in self._values.iteritems():
            settings.setValue(key, QVariant(val))

            
   #****************************************************************
   # Returns the value for setting key.
   #****************************************************************
    def value(self, key):
        if self._values.has_key(key):
            return QVariant(self._values[key])
        else:
            return QVariant()


   #****************************************************************
   # 
   #****************************************************************
    def valueAsBool(self, key):
        return self.value(key).toBool()
        

   #****************************************************************
   # Sets the value of setting key to value.
   #****************************************************************
    def setValue(self, key, value):
        self._values[key]=QVariant(value)


   #****************************************************************
   # 
   #****************************************************************
    def findPrograms(self):
        for key, program in self._programs.iteritems():
            if (self.value(key).toString().isEmpty()):
                path = subprocess.Popen(["which", program], stdout=subprocess.PIPE).communicate()[0]
                self.setValue(key, QString(path).trimmed()) 

          
 

      
